> For the complete documentation index, see [llms.txt](https://docs.v-nova.com/technologies/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.v-nova.com/technologies/mpeg-5.lcevc/encoder/sdk/eil/encoding-configuration-properties.md).

# Encoding Configuration Properties

The EIL provides a very powerful configuration system. All configuration properties, except for the basic frame information, are set via a JSON configuration string in the `EILInitSettings` structure.

The configuration system is supported by a comprehensive built-in system of optimised parameter defaults. The EIL employs ideal settings for both the LCEVC encoder and base encoder, based upon key parameters passed to it by the application, e.g., *resolution*, *bitrate*, *tune*.

Properties can be anonymously queried by the `EIL_QueryPropertyGroups` API, and, if the user knows the name of properties, by the `EIL_QueryProperty` API.

Properties specified within the JSON string override any setting provided by the database. Therefore, it is important that an application takes care to specify only properties within the JSON string that the user has explicitly set. For example, in a command-line program, only the options specified by the user in the command line should be included in the JSON string, or, from a GUI, only the options that the user has manually specified a choice for should be included in the JSON string.

The JSON string is processed utilising strong typing correlating to the target property type. If the types are not adhered to, then the EIL will fail to initialise. The user must take care to generate a JSON string that utilises the correct JSON type for each property type. The following table outlines the types and their JSON equivalents:

| EILPropertyType  | JSON type                                            |
| ---------------- | ---------------------------------------------------- |
| EIL\_PT\_Int32   | Number                                               |
| EIL\_PT\_Int64   | Number                                               |
| EIL\_PT\_Uint32  | Number                                               |
| EIL\_PT\_Uint64  | Number                                               |
| EIL\_PT\_Float   | Number                                               |
| EIL\_PT\_Double  | Number                                               |
| EIL\_PT\_String  | String                                               |
| EIL\_PT\_Boolean | Boolean, string (‘0’ = false), or number (0 = false) |
| EIL\_PT\_Blob    | Not used for properties                              |

The JSON string is formatted with a top-level object, and a member per property, as shown in the following example:

```c
{
 "encoding_downsample_luma" : "cubic",
 "temporal_enabled" : true,
 …
}
```

For additional convenience, properties have been assigned to logical groupings, and can optionally contain a description about what the property does. This is so a user may dynamically generate a command-line parser, or a UI, for the publicly available properties


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.v-nova.com/technologies/mpeg-5.lcevc/encoder/sdk/eil/encoding-configuration-properties.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
